// Kozak's Key Code Checker V1.4 by N's LAB  Copyright (C) 2006-2007 by Nobumichi Kozawa
import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import javax.microedition.rms.*;

public class KKeyCodeChecker extends MIDlet implements CommandListener
{
    EditScreen edit;

    Command exitCommand, aboutCommand, modeCommand;
    static Display disp;
    static int iKeyCode = 0;
    static String sKeyCode, sKeyMove;
    static int iMargin = 5, mode = 1;
    static boolean bInitial, bKeyDown, bKeyMove;

    public KKeyCodeChecker()
    {
        disp = Display.getDisplay(this);
        bInitial = true;
        bKeyDown = false;
        exitCommand = new Command("END", Command.EXIT, 1);
        modeCommand = new Command("Mode", Command.SCREEN, 1);
        aboutCommand = new Command("About", Command.SCREEN, 2);
        edit = new EditScreen();
        edit.setCommandListener(this);
//        edit.addCommand(exitCommand);
//        edit.addCommand(modeCommand);
        edit.addCommand(aboutCommand);
        disp.setCurrent(edit);
    }

    public void startApp(){ }
    public void pauseApp(){ }
    public void destroyApp(boolean unconditional){ }

    public void commandAction(Command command,Displayable screen)
    {
        if (command == exitCommand) {
            destroyApp(false);
            notifyDestroyed();
        } else if (command == modeCommand) {
        	mode++;
        	if (1 < mode) mode = 0;
        } else if (command == aboutCommand) {
        	Alert about = new Alert("About KKeyCodeChecker");
        	about.setTimeout(3000);
        	about.setType(AlertType.INFO);
        	about.setString("Kozak's Key Code Checker v1.3, this is free software. Copyright (C) 2006 by Nobumichi Kozawa");
        	disp.setCurrent(about);
        	bInitial = true;
        }
       	edit.repaint();
	}
	
    public class EditScreen extends Canvas
    {
        Font font;
        int iHeight, iWidth, ifh, ifw, iX, iY;
        String sChar;
        byte[] ba;

        public EditScreen()
        {
            font = Font.getFont(Font.FACE_MONOSPACE, Font.STYLE_PLAIN, Font.SIZE_MEDIUM);
            iWidth = getWidth();
            iHeight = getHeight();
            ifh = font.getHeight();
            ifw = font.charWidth('0');
            iX = iMargin;
            iY = 0;
            ba = new byte[1];
        }

        public void keyPressed(int keyCode)
        {
        	keyProc(keyCode, true);
        }

        public void keyReleased(int keyCode)
        {
        	keyProc(keyCode, false);
		}

		public void keyProc(int key, boolean down)
		{
        	bKeyDown = true;
        	sKeyMove = (down) ? "P" : "R";
        	bKeyMove = down;
        	iKeyCode = key;
        	sKeyCode = "0" + Integer.toHexString(key);
        	if (0x20 < iKeyCode && iKeyCode < 0x80) {
        		ba[0] = (byte)iKeyCode;
        		sChar = new String(ba);
        	} else sChar = "";
        	this.repaint();
        }

        public void paint(Graphics g)
        {
        	if (0 == iY && iMargin == iX) {
        		//iX = iMargin;
        		//iY = 0;
	            g.setFont(font);
    	        g.setColor(0x00FFFFFF);		
        	    g.fillRect(0, 0, iWidth, iHeight);
        	    bInitial = false;
        	}
        	if (bKeyDown) {
        		if (bKeyMove) g.setColor(0x00000000);
        		else g.setColor(0x00FF0000);
	            if (0 == mode) {
		            g.drawString(sKeyCode.substring(sKeyCode.length() - 2), iX, iY, Graphics.LEFT | Graphics.TOP);
		            iKeyCode = 0;
	    	        iX += ifw * 3;
	        	    if (iWidth < iX + ifw * 2 + iMargin) {
	            		iX = iMargin;
	            		iY += ifh;
	            		if (iHeight < iY + ifh) iY = 0;
	            	}
	        	} else {
		            g.drawString(sKeyMove + " " + sKeyCode + ", " + iKeyCode + ", " + sChar, iX, iY, Graphics.LEFT | Graphics.TOP);
		            iKeyCode = 0;
	        		iX = iMargin;
	        		iY += ifh;
	        		if (iHeight < iY + ifh) iY = 0;
	            }
	        }
	    }
    }
}
